/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net

**********************************************************************************/

/**
* Javascript functions for core/modules/amin/ADMINPLUGINS
*
* Not AJAX, but uses the WIKINDX AJAX framework for simplicity and efficiency
*
* @version 1.0
* @date February 2012
* @author Mark Grimshaw
*/

function disablePlugin()
{
	doTransfer('pluginsDisabled', 'pluginsEnabled');
}
function enablePlugin()
{
	doTransfer('pluginsEnabled', 'pluginsDisabled');
}
function disableStyle()
{
	doTransfer('stylesDisabled', 'stylesEnabled');
}
function enableStyle()
{
	doTransfer('stylesEnabled', 'stylesDisabled');
}
function disableLanguage()
{
	doTransfer('languagesDisabled', 'languagesEnabled');
}
function enableLanguage()
{
	doTransfer('languagesEnabled', 'languagesDisabled');
}
function disableTemplate()
{
	doTransfer('templatesDisabled', 'templatesEnabled');
}
function enableTemplate()
{
	doTransfer('templatesEnabled', 'templatesDisabled');
}
/**
* Transfer elements from source select box to target select box
*/
function doTransfer(target, source)
{
	var targetObj = f_getElement(target);
	var sourceObj = f_getElement(source);
	for(i = sourceObj.options.length - 1; i >= 0; i--)
	{
		if(sourceObj.options[i].selected)
		{
			targetObj.options[targetObj.options.length] = new Option(sourceObj.options[i].text, sourceObj.options[i].value);
			sourceObj.remove(i);
		}
	}
}
/**
* On submit, select all options in both enabled and disabled select boxes -- this allows PHP to pick up those options
*/
function selectAll()
{
	selectAllPlugins();
	selectAllStyles();
	selectAllLanguages();
	selectAllTemplates();
}
function selectAllPlugins()
{
	var objA = f_getElement('pluginsEnabled');
	var objB = f_getElement('pluginsDisabled');
	for(i = objA.options.length - 1; i >= 0; i--)
		objA.options[i].selected = true;
	for(i = objB.options.length - 1; i >= 0; i--)
		objB.options[i].selected = true;
}
function selectAllStyles()
{
	var objA = f_getElement('stylesEnabled');
	var objB = f_getElement('stylesDisabled');
	for(i = objA.options.length - 1; i >= 0; i--)
		objA.options[i].selected = true;
	for(i = objB.options.length - 1; i >= 0; i--)
		objB.options[i].selected = true;
}
function selectAllTemplates()
{
	var objA = f_getElement('templatesEnabled');
	var objB = f_getElement('templatesDisabled');
	for(i = objA.options.length - 1; i >= 0; i--)
		objA.options[i].selected = true;
	for(i = objB.options.length - 1; i >= 0; i--)
		objB.options[i].selected = true;
}
function selectAllLanguages()
{
	var objA = f_getElement('languagesEnabled');
	var objB = f_getElement('languagesDisabled');
	for(i = objA.options.length - 1; i >= 0; i--)
		objA.options[i].selected = true;
	for(i = objB.options.length - 1; i >= 0; i--)
		objB.options[i].selected = true;
}
/**
* Do something AJAXy in the 'targetDiv' based upon input from a multiple select box form element
*/
function triggerFromMultiSelect()
{
// Check we have the required input
	if(!A_OBJ[gateway.aobj_index].checkInput(['triggerField', 'targetDiv', 'script']))
		return false;
// Set the AJAX object's targetObj property
	A_OBJ[gateway.aobj_index].targetObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetDiv);
// Gather the selected OPTIONS of the triggerField select box
	var triggerObj = f_getElement(A_OBJ[gateway.aobj_index].input.triggerField);
	var len = triggerObj.options.length;
	var ajaxReturn = '';
	var triggerOptionValues = new Array();
	for(var i = 0; i < len; i++)
	{
		if(triggerObj.options[i].selected && (triggerObj.options[i].value != 0)) // don't include 'IGNORE'
			triggerOptionValues.push(triggerObj.options[i].value);
	}
	if(triggerOptionValues.length)
		ajaxReturn = '&ajaxReturn=' + triggerOptionValues.join();
// Gather the current selected OPTIONS of the targetDiv select box
	if(A_OBJ[gateway.aobj_index].input.restoreField != undefined)
	{
		var restoreObj = f_getElement(A_OBJ[gateway.aobj_index].input.restoreField);
		if(restoreObj)
		{
			len = restoreObj.options.length;
			var restoreOptionValues = new Array();
			for(var i = 0; i < len; i++)
			{
				if(restoreObj.options[i].selected && (restoreObj.options[i].value != 0)) // don't include 'IGNORE'
					restoreOptionValues.push(restoreObj.options[i].value);
			}
//alert(A_OBJ[gateway.aobj_index].input.targetDiv+ ' ' + restoreOptionValues.length);
			if(restoreOptionValues.length)
				ajaxReturn = ajaxReturn + '&ajaxReturn2=' + restoreOptionValues.join();
		}
	}
//alert(A_OBJ[gateway.aobj_index].input.targetDiv + ': ' + ajaxReturn);
	A_OBJ[gateway.aobj_index].processedScript = A_OBJ[gateway.aobj_index].input.script + ajaxReturn;
// Execute the AJAX
	if(!A_OBJ[gateway.aobj_index].doXmlHttp())
		return false;
	return true;
}
/**
* Open pop-up window
*/
function openReadMeWindow(url){
 browserDimensions2();
 var w = browserWidth * 0.8;
 var h = browserHeight * 0.9;
 var readMeWindow = window.open(url,'winReadMe','height=' + h + 
	',width=' + w + ',left=10,top=10,status,scrollbars,resizable,dependent');
}

/**
* Get browser dimensions.
* Code adapted from http://www.howtocreate.co.uk/tutorials/index.php?tut=0&part=16
*/
function browserDimensions2()
{
	if( typeof( window.innerWidth ) == 'number' )
	{
//Non-IE
		browserWidth = window.innerWidth;
		browserHeight  = window.innerHeight;
	}
	else if( document.documentElement &&
      ( document.documentElement.clientWidth || document.documentElement.clientHeight ) )
	{
//IE 6+ in 'standards compliant mode'
		browserWidth = document.documentElement.clientWidth;
		browserHeight  = document.documentElement.clientHeight;
	}
	else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) )
	{
//IE 4 compatible
		browserWidth = document.body.clientWidth;
		browserHeight  = document.body.clientHeight;
	}
}