/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2011
sirfragalot@users.sourceforge.net

**********************************************************************************/


/**
* Do something AJAXy in the 'targetDiv' based upon input from a multiple select box form element
*/
function triggerFromMultiSelect()
{
// Check we have the required input
	if(!A_OBJ[gateway.aobj_index].checkInput(['triggerField', 'targetDiv', 'script']))
		return false;
// Set the AJAX object's targetObj property
	A_OBJ[gateway.aobj_index].targetObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetDiv);
// Gather the selected OPTIONS of the triggerField select box
	var triggerObj = f_getElement(A_OBJ[gateway.aobj_index].input.triggerField);
	var len = triggerObj.options.length;
	var ajaxReturn = '';
	var triggerOptionValues = new Array();
	for(var i = 0; i < len; i++)
	{
		if(triggerObj.options[i].selected && (triggerObj.options[i].value != 0)) // don't include 'IGNORE'
			triggerOptionValues.push(triggerObj.options[i].value);
	}
	if(triggerOptionValues.length)
		ajaxReturn = '&ajaxReturn=' + triggerOptionValues.join();
// Gather the current selected OPTIONS of the targetDiv select box
	if(A_OBJ[gateway.aobj_index].input.restoreField != undefined)
	{
		var restoreObj = f_getElement(A_OBJ[gateway.aobj_index].input.restoreField);
		if(restoreObj)
		{
			len = restoreObj.options.length;
			var restoreOptionValues = new Array();
			for(var i = 0; i < len; i++)
			{
				if(restoreObj.options[i].selected && (restoreObj.options[i].value != 0)) // don't include 'IGNORE'
					restoreOptionValues.push(restoreObj.options[i].value);
			}
//alert(A_OBJ[gateway.aobj_index].input.targetDiv+ ' ' + restoreOptionValues.length);
			if(restoreOptionValues.length)
				ajaxReturn = ajaxReturn + '&ajaxReturn2=' + restoreOptionValues.join();
		}
	}
//alert(A_OBJ[gateway.aobj_index].input.targetDiv + ': ' + ajaxReturn);
	A_OBJ[gateway.aobj_index].processedScript = A_OBJ[gateway.aobj_index].input.script + ajaxReturn;
// Execute the AJAX
	if(!A_OBJ[gateway.aobj_index].doXmlHttp())
		return false;
	return true;
}

/**
* sets inner HTML of a DIV and restores the selected options in the select box
*/
function setDiv()
{
	var targetDivObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetDiv);
	var targetOptionValues = new Array();
	var targetBoxObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetBox);
// store selected options for later restoration
	if(targetBoxObj)
	{
		var len = targetBoxObj.options.length;
		for(var i = 0; i < len; i++)
		{
			if(targetBoxObj.options[i].selected && (targetBoxObj.options[i].value != 0)) // don't include 'IGNORE'
				targetOptionValues.push(targetBoxObj.options[i].value);
		}
	}
	targetDivObj.innerHTML = A_OBJ[gateway.aobj_index].input.targetContent;
// restore selected options
	targetBoxObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetBox);
	if(targetBoxObj && targetOptionValues.length)
	{
		len = targetBoxObj.length
		var found = false;
		for(var i = 0; i < len; i++)
		{
			for(var index in targetOptionValues)
			{
				if(targetOptionValues[index] == targetBoxObj.options[i].value)
				{
					targetBoxObj.options[i].selected = true;
					found = true;
				}
			}
		}
	}
	if(found) // deselect IGNORE
		targetBoxObj.options[0].selected = false;
}

