/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2011
sirfragalot@users.sourceforge.net

**********************************************************************************/

/**
* Javascript functions for core/modules/resource/RESOURCECATEGORYEDIT.php and TEXTQP.php
*
* Not AJAX, but uses the WIKINDX AJAX framework for simplicity and efficiency
*
* @version 1.0
* @date August 2011
* @author Mark Grimshaw
*/

function transferKeyword()
{
	doTransfer('keywords', 'fromKeywords');
}
function transferUserTag()
{
	doTransfer('userTags', 'fromUserTags');
}
/**
* Transfer elements from source select box to target textarea
*/
function doTransfer(target, source)
{
	var targetObj = f_getElement(target);
	var tempText = targetObj.value.split(',');
	var len = tempText.length;
	var targetText = new Array;
	var text;
	var selection;
	var split;
	for(var i = 0; i < len; i ++)
	{
		text = trim(tempText[i]);
		if(text)
			targetText.push(text);
	}
	var sourceObj = f_getElement(source);
	len = sourceObj.options.length;
	for(i = 0; i < len; i++)
	{
		split = sourceObj.options[i].value.split('_');
		selection = decode_base64(split[1]);
// When searching for existing word, we ignore case as different words may be indicated by different use of case on the same letters.
// i.e. we trust the user to get it right.
		if(sourceObj.options[i].selected && (searchArray(targetText, selection) == -1))
			targetText.push(selection);
	}
	targetObj.value = targetText.join(',');
}

function decode_base64(s)
{
	var e={},i,k,v=[],r='',w=String.fromCharCode;
	var n=[[65,91],[97,123],[48,58],[43,44],[47,48]];
	
	for(z in n){for(i=n[z][0];i<n[z][1];i++){v.push(w(i));}}
	for(i=0;i<64;i++){e[v[i]]=i;}
	
	for(i=0;i<s.length;i+=72){
	var b=0,c,x,l=0,o=s.substring(i,i+72);
		 for(x=0;x<o.length;x++)
		 {
			c=e[o.charAt(x)];b=(b<<6)+c;l+=6;
			while(l>=8){r+=w((b>>>(l-=8))%256);}
		 }
	}
	return r;
}