/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2011
sirfragalot@users.sourceforge.net

**********************************************************************************/

/**
* Initialize AJAX for the new resource form
*/
var Creator1_index;
var Creator2_index;
var Creator3_index;
var Creator4_index;
var Creator5_index;
var creatorIndexInitialized_1 = false;
var creatorIndexInitialized_2 = false;
var creatorIndexInitialized_3 = false;
var creatorIndexInitialized_4 = false;
var creatorIndexInitialized_5 = false;

//f_getElement('collectionOuter').style.display = 'none';
//f_getElement('conferenceOuter').style.display = 'none';

/**
* Do something AJAXy in the 'targetDiv' based upon input from a single select box form element
*/
function triggerFromSelect()
{
// Check we have the required input
	if(!A_OBJ[gateway.aobj_index].checkInput(['triggerField', 'targetDiv', 'script']))
		return false;
// Set the AJAX object's targetObj property
	A_OBJ[gateway.aobj_index].targetObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetDiv);
// Gather the selected OPTIONS of the triggerField select box
	var triggerObj = f_getElement(A_OBJ[gateway.aobj_index].input.triggerField);
	var ajaxReturn = '';
	ajaxReturn = '&ajaxReturn=' + triggerObj.value;
//alert(A_OBJ[gateway.aobj_index].input.targetDiv + ': ' + ajaxReturn);
	A_OBJ[gateway.aobj_index].processedScript = A_OBJ[gateway.aobj_index].input.script + ajaxReturn;
// Execute the AJAX
	if(!A_OBJ[gateway.aobj_index].doXmlHttp())
		return false;
	return true;
}
/**
* Do something AJAXy in the 'targetDiv' based upon input from a multiple select box form element
*/
function triggerFromMultiSelect()
{
// Check we have the required input
	if(!A_OBJ[gateway.aobj_index].checkInput(['triggerField', 'targetDiv', 'script']))
		return false;
// Set the AJAX object's targetObj property
	A_OBJ[gateway.aobj_index].targetObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetDiv);
// Gather the selected OPTIONS of the triggerField select box
	var triggerObj = f_getElement(A_OBJ[gateway.aobj_index].input.triggerField);
	var len = triggerObj.options.length;
	var ajaxReturn = '';
	var triggerOptionValues = new Array();
	for(var i = 0; i < len; i++)
	{
		if(triggerObj.options[i].selected && (triggerObj.options[i].value != 0)) // don't include 'IGNORE'
			triggerOptionValues.push(triggerObj.options[i].value);
	}
	if(triggerOptionValues.length)
		ajaxReturn = '&ajaxReturn=' + triggerOptionValues.join();
// Gather the current selected OPTIONS of the targetDiv select box
	if(A_OBJ[gateway.aobj_index].input.restoreField != undefined)
	{
		var restoreObj = f_getElement(A_OBJ[gateway.aobj_index].input.restoreField);
		if(restoreObj)
		{
			len = restoreObj.options.length;
			var restoreOptionValues = new Array();
			for(var i = 0; i < len; i++)
			{
				if(restoreObj.options[i].selected && (restoreObj.options[i].value != 0)) // don't include 'IGNORE'
					restoreOptionValues.push(restoreObj.options[i].value);
			}
	//alert(A_OBJ[gateway.aobj_index].input.targetDiv+ ' ' + restoreOptionValues.length);
			if(restoreOptionValues.length)
				ajaxReturn = ajaxReturn + '&ajaxReturn2=' + restoreOptionValues.join();
		}
	}
//alert(A_OBJ[gateway.aobj_index].input.targetDiv + ': ' + ajaxReturn);
	A_OBJ[gateway.aobj_index].processedScript = A_OBJ[gateway.aobj_index].input.script + ajaxReturn;
// Execute the AJAX
	if(!A_OBJ[gateway.aobj_index].doXmlHttp())
		return false;
	return true;
}
/**
* Start the process of javascript validating RESOURCEFORM input
*/
function validate()
{
// Check we have the required input
	if(!A_OBJ[gateway.aobj_index].checkInput(['targetDiv', 'script', 'requiredArray']))
		return false;
// Set the AJAX object's targetObj property
	A_OBJ[gateway.aobj_index].targetObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetDiv);
	var names = [];
	var values = [];
	var multiNameObj;
	var multiValues = [];
	var count = 0;
	var countMulti = 0;
	var form = f_getElement('resourceForm');
	for(var i = 0; i < form.elements.length; i++)
	{
		if(form.elements[i].value != 0)
		{
			if((form.elements[i].name == 'action') || (form.elements[i].name == 'utf8CharTest'))
				continue;
			if(form.elements[i].type == 'select-multiple')
			{
				multiNameObj = form.elements[i];
				for(var x = 0; x < multiNameObj.length; x++)
				{
					if(multiNameObj[x].selected)
					{
						multiValues[countMulti] = multiNameObj[x].value;
						countMulti++;
					}
				}
				if(multiValues.length > 0)
				{
					names[count] = form.elements[i].name;
					values[count] = multiValues.join(',');
					multiValues = [];
					countMulti = 0;
				}
			}
			else
			{
				names[count] = form.elements[i].name;
				values[count] = trim(form.elements[i].value);
			}
		}
		count++;
	}
	if(!validateInput(names, values))
		return false; // stop form submit
// If we get here, validation has been passed
	return true; // continue form submit (see ajax::gateway())
}
/**
* Check and validate input
*/
function validateInput(names, values)
{
	tinyMCE.triggerSave(); // See http://www.tinymce.com/forum/viewtopic.php?id=28
// Check resource title
//alert(f_getElement('resourceTitle').value);
// tinyMCE converts returns to <p> tags and encloses more than two spaces with <p> tags
//	f_getElement('resourceTitle').value = f_getElement('resourceTitle').value.replace(new RegExp("<p>|<\/p>+", "ig"), '');
	f_getElement('resourceTitle').value = f_getElement('resourceTitle').value.replace(/<(?:.|\n)*?>/gm, '');
//	f_getElement('resourceSubtitle').value = f_getElement('resourceSubtitle').value.replace(/<(?:.|\n)*?>/gm, '');
	if(!removeNonPrintable(trim(f_getElement('resourceTitle').value)))
	{
		validateError('resourceTitle', 'missing');
		return false;
	}
	if((rtIndex = searchArray(names, 'resourceType')) == -1)
		return false;
	var resourceType = values[rtIndex];
	var requiredArray = A_OBJ[gateway.aobj_index].input.requiredArray;
	requiredArray = JSON.parse(requiredArray.replace(/&quot;/g, "\""));
// Check required inputs
	for(var i in requiredArray)
	{
		if(i != resourceType)
			continue;
		var str = String(requiredArray[i]);
		if((str == 'collectionTitle') && (searchArray(names, 'collectionId') != -1))
			continue;
		else if((str == 'collectionTitle') && (searchArray(names, 'conferenceId') != -1))
			continue;
		if((str == 'publisherpublisherName') && (searchArray(names, 'publisherId') != -1))
			continue;
		if((str == 'publishertransPublisherName') && (searchArray(names, 'transPublisherId') != -1))
			continue;
		var spl = str.split(",");
		for(var id = 0; id < spl.length; id++)
		{
			var nameIndex = searchArray(names, spl[id]);
			if(nameIndex == -1)
			{
				validateError(spl[id], 'missing');
				return false;
			}
		}
	}
	var creatorCount = 0;
	var checkSurname = new Array();
	for(i = 0; i < names.length; i++)
	{
		if(!names[i])
			continue;
// check resourcemiscXXX field values are all integers excepting 'PeerReviewed'
		if(String(names[i]).indexOf('resourcemisc') == 0) // at the start
		{
			if(names[i] == 'resourcemiscPeerReviewed')
				continue;
			if(!is_integer(values[i]))
			{
				validateError(names[i], 'nan');
				return false;
			}
		}
// check creators -- '_surname' must exist if another field (except '_select') has an entry
		if(String(names[i]).indexOf('Creator') == 0) // at the start
		{
			var str = String(names[i]);
			var spl = str.split("_");
			if((spl[2] == 'firstname') || (spl[2] == 'initials') || (spl[2] == 'prefix'))
			{
				checkSurname[creatorCount] = spl[0] + '_' + spl[1] + '_surname'; // store surname field to check
				creatorCount++;
			}
		}
	}
	for(i = 0; i < checkSurname.length; i++)
	{
		cIndex = searchArray(names, checkSurname[i]);
		if((cIndex == -1) || !values[cIndex])
			{
				validateError(checkSurname[i], 'missing');
				return false;
			}
	}
	return true;
}
/**
* Finish the process of javascript validation of RESOURCEFORM input when there is an error
*/
function validateError(field, error)
{
// Set the AJAX object's targetObj property
	var ajaxReturn = '&field=' + field + '&error=' + error;
	A_OBJ[gateway.aobj_index].targetObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetDiv);
	A_OBJ[gateway.aobj_index].processedScript = A_OBJ[gateway.aobj_index].input.script + ajaxReturn;
// Execute the AJAX
	if(!A_OBJ[gateway.aobj_index].doXmlHttp())
		return false;
	return false; // stop form submit
}
/**
* Add a creator field
*/
function addCreator()
{
// Check we have the required input
	if(!A_OBJ[gateway.aobj_index].checkInput(['creatorType', 'script', 'type']))
		return false;
	var jObj = new Object;
	createJObj('increment', jObj); // NB objects passed by reference
// Set the AJAX object's targetObj property
	A_OBJ[gateway.aobj_index].targetObj = f_getElement(A_OBJ[gateway.aobj_index].input.creatorType + '_Inner');
//alert(A_OBJ[gateway.aobj_index].targetObj + ': ' + A_OBJ[gateway.aobj_index].input.creatorType);
	var ajaxReturn = '&ajaxReturn=' + JSON.stringify(jObj);
//alert(JSON.stringify(jObj));
	A_OBJ[gateway.aobj_index].processedScript = A_OBJ[gateway.aobj_index].input.script + ajaxReturn;
// Execute the AJAX
	if(!A_OBJ[gateway.aobj_index].doXmlHttp())
		return false;
	return true;
}
/**
* Remove a creator field
*/
function removeCreator()
{
// Check we have the required input
	if(!A_OBJ[gateway.aobj_index].checkInput(['creatorType', 'script', 'type']))
		return false;
	var jObj = new Object;
	createJObj('decrement', jObj);
// Set the AJAX object's targetObj property
	A_OBJ[gateway.aobj_index].targetObj = f_getElement(A_OBJ[gateway.aobj_index].input.creatorType + '_Inner');
//alert(A_OBJ[gateway.aobj_index].targetObj + ': ' + A_OBJ[gateway.aobj_index].input.creatorType);
	var ajaxReturn = '&ajaxReturn=' + JSON.stringify(jObj);
//alert(JSON.stringify(jObj));
	A_OBJ[gateway.aobj_index].processedScript = A_OBJ[gateway.aobj_index].input.script + ajaxReturn;
// Execute the AJAX
	if(!A_OBJ[gateway.aobj_index].doXmlHttp())
		return false;
	return true;
}
/**
* Populate the jObj object that, for one creatorType, stores existing creator fields and the field index counter.
* NB jObj is an object and so is passed in by reference
*/
	function createJObj(action, jObj)
	{
		if(A_OBJ[gateway.aobj_index].input.creatorType == 'Creator1')
		{
			if(!creatorIndexInitialized_1)
			{
				if(A_OBJ[gateway.aobj_index].input.index == undefined) // new resource
					Creator1_index = 0;
				else	// editing resource
					Creator1_index = A_OBJ[gateway.aobj_index].input.index;
				creatorIndexInitialized_1 = true;
			}
//alert('Creator1_index: ' + Creator1_index);
			if(action == 'increment')
				jObj.index = ++Creator1_index;
			else if(Creator1_index > 0)
				jObj.index = --Creator1_index;
			else
				jObj.index = 0; // default
		}
		else if(A_OBJ[gateway.aobj_index].input.creatorType == 'Creator2')
		{
			if(!creatorIndexInitialized_2)
			{
				if(A_OBJ[gateway.aobj_index].input.index == undefined)
					Creator2_index = 0;
				else
					Creator2_index = A_OBJ[gateway.aobj_index].input.index;
				creatorIndexInitialized_2 = true;
			}
//alert('Creator2_index: ' + Creator2_index);
			if(action == 'increment')
				jObj.index = ++Creator2_index;
			else if(Creator2_index > 0)
				jObj.index = --Creator2_index;
			else
				jObj.index = 0; // default
		}
		else if(A_OBJ[gateway.aobj_index].input.creatorType == 'Creator3')
		{
			if(!creatorIndexInitialized_3)
			{
				if(A_OBJ[gateway.aobj_index].input.index == undefined)
					Creator3_index = 0;
				else
					Creator3_index = A_OBJ[gateway.aobj_index].input.index;
				creatorIndexInitialized_3 = true;
			}
			if(action == 'increment')
				jObj.index = ++Creator3_index;
			else if(Creator3_index > 0)
				jObj.index = --Creator3_index;
			else
				jObj.index = 0; // default
		}
		else if(A_OBJ[gateway.aobj_index].input.creatorType == 'Creator4')
		{
			if(!creatorIndexInitialized_4)
			{
				if(A_OBJ[gateway.aobj_index].input.index == undefined)
					Creator4_index = 0;
				else
					Creator4_index = A_OBJ[gateway.aobj_index].input.index;
				creatorIndexInitialized_4 = true;
			}
			if(action == 'increment')
				jObj.index = ++Creator4_index;
			else if(Creator4_index > 0)
				jObj.index = --Creator4_index;
			else
				jObj.index = 0; // default
		}
		else if(A_OBJ[gateway.aobj_index].input.creatorType == 'Creator5')
		{
			if(!creatorIndexInitialized_5)
			{
				if(A_OBJ[gateway.aobj_index].input.index == undefined)
					Creator5_index = 0;
				else
					Creator5_index = A_OBJ[gateway.aobj_index].input.index;
				creatorIndexInitialized_5 = true;
			}
			if(action == 'increment')
				jObj.index = ++Creator5_index;
			else if(Creator5_index > 0)
				jObj.index = --Creator5_index;
			else
				jObj.index = 0; // default
		}
		var fieldName;
		jObj.creatorFields = new Object;
		for(var fieldIndex = 0; fieldIndex < jObj.index; fieldIndex++)
		{
			fieldName = A_OBJ[gateway.aobj_index].input.creatorType + '_' + fieldIndex + '_firstname';
			getObjValue(fieldName, jObj);
			fieldName = A_OBJ[gateway.aobj_index].input.creatorType + '_' + fieldIndex + '_initials';
			getObjValue(fieldName, jObj);
			fieldName = A_OBJ[gateway.aobj_index].input.creatorType + '_' + fieldIndex + '_prefix';
			getObjValue(fieldName, jObj);
			fieldName = A_OBJ[gateway.aobj_index].input.creatorType + '_' + fieldIndex + '_surname';
			getObjValue(fieldName, jObj);
			fieldName = A_OBJ[gateway.aobj_index].input.creatorType + '_' + fieldIndex + '_select';
			getObjValue(fieldName, jObj, true);
		}
	}
/**
* return an object's value
*/
	function getObjValue(fieldName, jObj, selectBox)
	{
		if((fieldObj = f_getElement(fieldName)) != null)
		{
			var value;
			if(selectBox == undefined)
			{
				if(value = trim(fieldObj.value))
					jObj.creatorFields[fieldName] = value;
			}
			else // selectBox
			{
				if((value = fieldObj.value) > 0) // ignore IGNORE
					jObj.creatorFields[fieldName] = value;
			}
		}
	}
/**
* sets inner HTML of a DIV
*/
function setDiv()
{
	var targetDivObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetDiv);
	targetDivObj.innerHTML = A_OBJ[gateway.aobj_index].input.targetContent;
}
/**
* sets DIV as visible or not
*/
function divVisibility()
{
	var targetDivObj = f_getElement(A_OBJ[gateway.aobj_index].input.targetDiv);
//alert(A_OBJ[gateway.aobj_index].input.targetDiv + ': ' + A_OBJ[gateway.aobj_index].input.targetContent);
	if(A_OBJ[gateway.aobj_index].input.targetState == 'visible')
		targetDivObj.style.display = 'block';
	else
		targetDivObj.style.display = 'none';
//alert(A_OBJ[gateway.aobj_index].input.targetDiv + ': ' + targetDivObj.style.display);
}
function transferKeyword()
{
	doTransfer('keywordList', 'resourcekeywordKeywords');
}
function transferUserTag()
{
	doTransfer('userTagList', 'resourceusertagsTagId');
}
/**
* Transfer elements from source select box to target textarea
*/
function doTransfer(target, source)
{
	var targetObj = f_getElement(target);
	var tempText = targetObj.value.split(',');
	var len = tempText.length;
	var targetText = new Array;
	var text;
	var selection;
	var split;
	for(var i = 0; i < len; i ++)
	{
		text = trim(tempText[i]);
		if(text)
			targetText.push(text);
	}
	var sourceObj = f_getElement(source);
	len = sourceObj.options.length;
	for(i = 0; i < len; i++)
	{
		split = sourceObj.options[i].value.split('_');
		selection = decode_base64(split[1]);
// When searching for existing word, we ignore case as different words may be indicated by different use of case on the same letters.
// i.e. we trust the user to get it right.
		if(sourceObj.options[i].selected && (searchArray(targetText, selection) == -1))
			targetText.push(selection);
	}
	targetObj.value = targetText.join(',');
}

function decode_base64(s)
{
	var e={},i,k,v=[],r='',w=String.fromCharCode;
	var n=[[65,91],[97,123],[48,58],[43,44],[47,48]];
	
	for(z in n){for(i=n[z][0];i<n[z][1];i++){v.push(w(i));}}
	for(i=0;i<64;i++){e[v[i]]=i;}
	
	for(i=0;i<s.length;i+=72){
	var b=0,c,x,l=0,o=s.substring(i,i+72);
		 for(x=0;x<o.length;x++)
		 {
			c=e[o.charAt(x)];b=(b<<6)+c;l+=6;
			while(l>=8){r+=w((b>>>(l-=8))%256);}
		 }
	}
	return r;
}