<?php
/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2011
sirfragalot@users.sourceforge.net
**********************************************************************************/
/**
* PREFERENCES class
*
* User preferences
*/
class PREFERENCES
{
private $errors;
private $messages;
private $success;
private $template;
private $session;
private $config;
private $db;
private $vars;
private $badInput;
private $form;
private $html;
private $table;

	public function __construct()
	{
		$this->errors = FACTORY_ERRORS::getInstance();
		$this->messages = FACTORY_MESSAGES::getInstance();
		$this->success = FACTORY_SUCCESS::getInstance();
		$this->template = FACTORY_TEMPLATE::getInstance();
		$this->session = FACTORY_SESSION::getInstance();
		$this->config = FACTORY_CONFIG::getInstance();
		$this->vars = GLOBALS::getVars();
		$this->badInput = FACTORY_BADINPUT::getInstance();
		$this->form = FACTORY_FORM::getInstance();
		$this->html = FACTORY_HTML::getInstance();
		$this->table = FACTORY_TABLE::getInstance();
		$this->loadStyle = FACTORY_LOADSTYLE::getInstance();
		GLOBALS::setOutputHeading($this->messages->text("heading", "configure"));
	}
// display options
	public function init($error = FALSE)
	{
		include_once("core/modules/help/HELPMESSAGES.php");
		$help = new HELPMESSAGES();
		GLOBALS::setOutputHelp($help->createLink('preferences'));
		GLOBALS::setOutputHeading($this->messages->text("heading", "configure"));
		$pString = $this->form->formHeader('usersgroups_PREFERENCES_CORE');
		$pString .= $this->form->hidden("method", "write");
		if($error)
		{
			$pString .= $error;
// As language may have changed, we create a new MESSAGES and SUCCESS object.
			$this->messages = new MESSAGES();
		}
		$pString .= $this->table->tableStart('generalTable', 1, 0, 0, "left");
		$pString .= $this->table->trStart();
		$pString .= $this->table->td($this->form->textInput($this->messages->text("config", "paging"), "Paging", 
			$this->session->getVar("setup_Paging"), 5) . " " . $this->html->span('*', 'required') . $this->html->br() . 
			$this->html->span($this->messages->text("hint", "pagingLimit"), 'hint'));
		$pString .= $this->table->td($this->form->textInput($this->messages->text("config", "maxPaging"), "PagingMaxLinks", 
			$this->session->getVar("setup_PagingMaxLinks"), 5) . " " . $this->html->span('*', 'required'));
		if(!$this->session->getVar("setup_PagingTagCloud"))
			$this->session->setVar("setup_PagingTagCloud", 100);
		$pString .= $this->table->td($this->form->textInput($this->messages->text("config", "pagingTagCloud"), "PagingTagCloud", 
			$this->session->getVar("setup_PagingTagCloud"), 5) . " " . $this->html->span('*', 'required') . 
			$this->html->br() . $this->html->span($this->messages->text("hint", "pagingLimit"), 'hint'));
		$pString .= $this->table->td($this->form->textInput($this->messages->text("config", "stringLimit"), "StringLimit", 
			$this->session->getVar("setup_StringLimit"), 5) . " " . $this->html->span('*', 'required') . $this->html->br() . 
			$this->html->span($this->messages->text("hint", "pagingLimit"), 'hint'));
		$pString .= $this->table->trEnd();
		$pString .= $this->table->tableEnd();
		
		$pString .= $this->table->tableStart('generalTable', 1, 0, 0, "left");
		$pString .= $this->table->trStart();
		$input = $this->session->getVar("setup_PagingStyle") == 'A' ? "CHECKED" : FALSE;
		$pString .= $this->table->td($this->form->checkbox($this->messages->text("config", "pagingStyle"), 
			"PagingStyle", $input));
		$input = $this->session->getVar("setup_UseWikindxKey") ? "CHECKED" : FALSE;
		$pString .= $this->table->td($this->form->checkbox($this->messages->text("config", "useWikindxKey"), 
			"UseWikindxKey", $input));
		$input = $this->session->getVar("setup_UseBibtexKey") ? "CHECKED" : FALSE;
		$pString .= $this->table->td($this->form->checkbox($this->messages->text("config", "useBibtexKey"), 
			"UseBibtexKey", $input));
		$pString .= $this->table->trEnd();
		$pString .= $this->table->tableEnd();
		
		$pString .= $this->table->tableStart('generalTable', 1, 0, 0, "left");
		$pString .= $this->table->trStart();
		$input = $this->session->getVar("setup_DisplayBibtexLink") ? "CHECKED" : FALSE;
		$pString .= $this->table->td($this->form->checkbox($this->messages->text("config", "displayBibtexLink"), 
			"DisplayBibtexLink", $input));
		$input = $this->session->getVar("setup_DisplayCmsLink") ? "CHECKED" : FALSE;
		$pString .= $this->table->td($this->form->checkbox($this->messages->text("config", "displayCmsLink"), 
			"DisplayCmsLink", $input));
		$input = $this->session->getVar("setup_Listlink") ? "CHECKED" : FALSE;
		$pString .= $this->table->td($this->form->checkbox($this->messages->text("config", "listlink"), "Listlink", $input));
		$pString .= $this->table->trEnd();
		$pString .= $this->table->tableEnd();
		
		$pString .= $this->table->tableStart('generalTable', 1, 0, 0, "left");
		$pString .= $this->table->trStart();
		$template = FACTORY_TEMPLATE::getInstance();
		$templates = $template->loadDir();
		$subTd = $this->table->tableStart();
		$subTd .= $this->table->trStart();
		if(array_key_exists($this->session->getVar("setup_Template"), $templates))
			$subTd .= $this->table->td($this->form->selectedBoxValue($this->messages->text("config", "template"), 
				"Template", $templates, $this->session->getVar("setup_Template"), 4)
				 . " " . $this->html->span('*', 'required'));
		else
			$subTd .= $this->table->td($this->form->selectFBoxValue($this->messages->text("config", "template"), 
				"Template", $templates, 4)
				 . " " . $this->html->span('*', 'required'));
		$menus[0] = $this->messages->text("config", "templateMenu1");
		$menus[1] = $this->messages->text("config", "templateMenu2");
		$menus[2] = $this->messages->text("config", "templateMenu3");
		$subTd .= $this->table->td($this->form->selectedBoxValue($this->messages->text("config", "templateMenu"), 
			"TemplateMenu", $menus, $this->session->getVar("setup_TemplateMenu"), 3)
			 . " " . $this->html->span('*', 'required'));
		$subTd .= $this->table->trEnd();
		$subTd .= $this->table->tableEnd();
		$pString .= $this->table->td($subTd);
		$language = FACTORY_MESSAGES::getInstance();
		$languages = $language->loadDir();
		if(array_key_exists($this->session->getVar("setup_Language"), $languages))
			$pString .= $this->table->td($this->form->selectedBoxValue($this->messages->text("config", "language"), 
				"Language", $languages, $this->session->getVar("setup_Language")) 
				 . " " . $this->html->span('*', 'required'));
		else
			$pString .= $this->table->td($this->form->selectFBoxValue($this->messages->text("config", "language"), 
				"Language", $languages) . " " . $this->html->span('*', 'required'));
		$styles = $this->loadStyle->loadDir("styles/bibliography");
		if(array_key_exists($this->session->getVar("setup_Style"), $styles))
			$pString .= $this->table->td($this->form->selectedBoxValue($this->messages->text("config", "style") , "Style", 
				$styles, $this->session->getVar("setup_Style"), 4) . " " . $this->html->span('*', 'required'));
		else
			$pString .= $this->table->td($this->form->selectFBoxValue($this->messages->text("config", "style") , "Style", 
				$styles, 4) . " " . $this->html->span('*', 'required'));
		$pString .= $this->table->trEnd();
		$pString .= $this->table->tableEnd();
		
		$pString .= $this->html->p($this->form->formSubmit());
		$pString .= $this->form->formEnd();
		GLOBALS::buildOutputString($pString);
	}
// write preferences
	function write()
	{
// checkInput writes the session
		$this->checkInput();
// If this is a logged on user, write preferences to WKX_user_preferences
		if($userId = $this->session->getVar("setup_UserId"))
		{
			$user = FACTORY_USER::getInstance();
			$user->writePreferences($userId);
		}
// As template may have changed, destroy the existing template object.
		unset($this->template);
// As language may have changed, we destroy the existing one then create new objects
		FACTORY_MESSAGES::getFreshInstance();
		FACTORY_ERRORS::getFreshInstance();
		FACTORY_HELP::getFreshInstance();
		$this->success = FACTORY_SUCCESS::getFreshInstance();
		$this->init($this->success->text("config"));
	}
// Check input
	function checkInput()
	{
		$required = array("Language", "Template", "Style", "Paging", "PagingMaxLinks", "StringLimit", "PagingTagCloud");
		foreach($required as $value)
		{
			if(!array_key_exists($value, $this->vars) || !$this->vars[$value])
				$this->badInput->close($this->errors->text("inputError", "missing", " ($value) "), $this, 'init');
			else
				$array[$value] = $this->vars[$value];
		}
		if(!array_key_exists("TemplateMenu", $this->vars))
			$this->badInput->close($this->errors->text("inputError", "missing", " (TemplateMenu) "), $this, 'init');
		else
			$array['TemplateMenu'] = $this->vars['TemplateMenu'];
		if(!is_numeric($this->vars['Paging']))
			$this->badInput->close($this->errors->text("inputError", "nan", " (paging) "), $this, 'init');
		if(!is_numeric($this->vars['PagingTagCloud']))
			$this->badInput->close($this->errors->text("inputError", "nan", " (paging) "), $this, 'init');
		if(!is_numeric($this->vars['PagingMaxLinks']))
			$this->badInput->close($this->errors->text("inputError", "nan", " (pagingMaxLinks) "), $this, 'init');
		if(!is_numeric($this->vars['StringLimit']))
			$this->badInput->close($this->errors->text("inputError", "nan", " (stringLimit) "), $this, 'init');
// All input good - write to session
		$this->session->writeArray($array, "setup");
		if(array_key_exists("PagingStyle", $this->vars))
			$this->session->setVar("setup_PagingStyle", 'A');
		else
			$this->session->delVar("setup_PagingStyle");
		$this->session->delVar("sql_LastMulti"); // always reset in case of paging changes
		if(array_key_exists("UseWikindxKey", $this->vars))
			$this->session->setVar("setup_UseWikindxKey", TRUE);
		else
			$this->session->delVar("setup_UseWikindxKey");
		if(array_key_exists("UseBibtexKey", $this->vars))
			$this->session->setVar("setup_UseBibtexKey", TRUE);
		else
			$this->session->delVar("setup_UseBibtexKey");
		if(array_key_exists("DisplayBibtexLink", $this->vars))
			$this->session->setVar("setup_DisplayBibtexLink", TRUE);
		else
			$this->session->delVar("setup_DisplayBibtexLink");
		if(array_key_exists("DisplayCmsLink", $this->vars))
			$this->session->setVar("setup_DisplayCmsLink", TRUE);
		else
			$this->session->delVar("setup_DisplayCmsLink");
		if(array_key_exists("Listlink", $this->vars))
			$this->session->setVar("setup_Listlink", TRUE);
		else
			$this->session->delVar("setup_Listlink");
	}
}
?>
