<?php
/**
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program;
if not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2012
sirfragalot@users.sourceforge.net
*/
/**
* MENU
*
* Configure, create and print menus
* 
* @version	1
*
*	@package wikindx4\core\navigation
*	@author Mark Grimshaw <sirfragalot@users.sourceforge.net>
*
*/
class MENU
{
/** object */
private $db;
/** object */
private $session;
/** object */
private $template;
/** object */
private $quarantine;
/** array */
private $topLevel = array();
/** array */
private $menuSub = array();
/** array */
private $wikindx;
/** array */
private $res;
/** array */
private $search;
/** array */
private $text;
/** array */
private $admin;
/** array */
private $plugin1;
/** array */
private $plugin2;
/** array */
private $plugin3;
/** object */
private $config;
/** string */
private $superAdmin;
/** string */
private $write;
/** id */
private $userId;
/** string */
private $multiUser;
/** string */
private $userRegistration;
/** array */
private $bibliographies;
/** array */
private $bookmarkArray;
/** string */
private $bookmarkAdd;
/** string */
private $lastSolo;
/** string */
private $stmt;
/** string */
private $lastMulti;
/** boolean */
private $lastMultiMeta;
/** array */
private $basketList;
/** string */
private $importBib;
/** boolean */
private $buildMenu = TRUE;
/** object */
private $html;
/** array */
private $outputArray = array();
/** object */
private $collObject;
/** object */
private $pubObject;
/** boolean */
private $resourcesExist = FALSE;
/** boolean */
private $metadataExist = FALSE;
/** int */
private $reduceMenuLevel;
/** string */
private $reduceMenuLevelPretext = '';

/** boolean */
private $pluginsExist = FALSE;

/**
* MENU class
*/
	public function __construct()
	{
		$this->db = FACTORY_DB::getInstance();
		$this->session = FACTORY_SESSION::getInstance();
		$this->template = FACTORY_TEMPLATE::getInstance();
		include_once('core/modules/admin/QUARANTINE.php');
		$this->quarantine = new QUARANTINE();
		$this->config = FACTORY_CONFIG::getInstance();
		$this->collObject = FACTORY_COLLECTION::getInstance();
		$this->pubObject = FACTORY_PUBLISHER::getInstance();
		$file = FACTORY_FILE::getInstance();
		$this->superAdmin = $this->session->getVar("setup_Superadmin");
		if($this->superAdmin)

		{
			$handle = opendir('plugins');
			while(FALSE !== ($dir = readdir($handle)))
			{
				if($dir == '..')
					continue;
				if(is_dir('plugins/' . $dir) && file_exists('plugins/' . $dir . '/index.php'))
					$this->pluginsExist = TRUE;
			}
		}
		$this->write = $this->session->getVar("setup_Write");
		$this->userId = $this->session->getVar("setup_UserId");
		$this->userRegistration = $this->session->getVar("setup_UserRegistration");
		$this->reduceMenuLevel = $this->session->getVar("setup_ReduceMenuLevel");
		if($this->session->issetVar("setup_ReduceMenuLevelPretext"))
			$this->reduceMenuLevelPretext = $this->session->getVar("setup_ReduceMenuLevelPretext");
		$row = $this->db->fetchRow($this->db->select('database_summary', array('databaseSummaryTotalResources', 
			'databaseSummaryTotalQuotes', 'databaseSummaryTotalParaphrases', 'databaseSummaryTotalMusings')));
		if($row['databaseSummaryTotalResources'])
			$this->resourcesExist = TRUE;
// Admin may have turned off metadata subsystem. Default for $this->metadataExist is FALSE in the class constructor
		if($this->session->getVar('setup_Superadmin')
			&& 
			($row['databaseSummaryTotalQuotes'] || $row['databaseSummaryTotalParaphrases'] || $row['databaseSummaryTotalMusings']))
				$this->metadataExist = TRUE;
		else if(($this->session->getVar('setup_MetadataAllow') == 'N'))
		{
			if(($this->session->getVar('setup_MetadataUserOnly') == 'Y') && $this->session->getVar('setup_UserId')
				&&
				($row['databaseSummaryTotalQuotes'] || $row['databaseSummaryTotalParaphrases'] || $row['databaseSummaryTotalMusings']))
					$this->metadataExist = TRUE;
		}
		else if(($this->session->getVar('setup_MetadataAllow') == 'Y')
			&& 
			($row['databaseSummaryTotalQuotes'] || $row['databaseSummaryTotalParaphrases'] || $row['databaseSummaryTotalMusings']))
				$this->metadataExist = TRUE;
		$stateArray[] = $this->multiUser = $this->session->getVar("setup_MultiUser");
		$stateArray[] = $this->bibliographies = $this->session->getVar("setup_Bibliographies");
		$stateArray[] = $this->bookmarkArray = $this->session->getArray('bookmark');
		if(is_array($this->bookmarkArray))
		{
			if(array_key_exists('DisplayAdd', $this->bookmarkArray))
				$stateArray[] = $this->bookmarkAdd = $this->bookmarkArray['DisplayAdd'];
			if(array_key_exists('View', $this->bookmarkArray))
				$stateArray[] = $this->bookmarkView = $this->bookmarkArray['View'];
		}
		$stateArray[] = $this->lastSolo = $this->session->getVar("sql_LastSolo");
		$stateArray[] = $this->stmt = $this->session->getVar("sql_Stmt");
		$stateArray[] = $this->lastMulti = $this->session->getVar("sql_LastMulti");
		$stateArray[] = $this->lastMultiMeta = $this->session->getVar("sql_LastMultiMeta");
		$stateArray[] = $this->basketList = $this->session->getVar("basket_List");
		$stateArray[] = $this->importBib = $this->session->getVar("setup_ImportBib");
		$state = base64_encode(serialize($stateArray));
		if($state == $this->session->getVar('menu_state') && ($menu = SmartyMenu::loadMenu('menu_menu')) !== false)
		{
			$this->template->tpl->assign('menu', $menu);
			return;
		}
		$this->session->setVar('menu_state', $state);
	}
/**
* configure menus
*/
	private function configure()
	{
		$messages = FACTORY_MESSAGES::getInstance();
// Build dummy plugin array
		$this->plugin1 = array($messages->text("menu", "plugin1")	=>	'index.php?action=noMenu&method=plugin1');
		$this->plugin2 = array($messages->text("menu", "plugin2")	=>	'index.php?action=noMenu&method=plugin2');
		$this->plugin3 = array($messages->text("menu", "plugin3")	=>	'index.php?action=noMenu&method=plugin3');
// Build arrays of menus items.  First element of array name is main menu item name, subsequent elements are the names
// of the submenu with its
// hyperlink.  This provides easy access for both building CSS menus and for displaying links for non-CSS drop-down
// web browsers.
		$this->wikindx = array(
				'Wikindx'				=>	'index.php?action=noMenu&method=wikindx',
				$messages->text("menu", "home")		=>	'index.php',
			);
		if($this->session->getVar('setup_News'))
			$this->wikindx[$messages->text("menu", "news")] = 'index.php?action=news_NEWS_CORE&method=viewNews';
		if($this->bibliographies && $this->write)
			$this->wikindx[$messages->text("menu", "bibs")] = 'index.php?action=bibliography_CHOOSEBIB_CORE';
		$this->wikindx[$messages->text("menu", "prefs")] = 'index.php?action=usersgroups_PREFERENCES_CORE';
		if($this->userId)
		{
			$this->wikindx[$messages->text("menu", "myWikindx")] = 'index.php?action=usersgroups_MYWIKINDX_CORE';
			$this->wikindx[$messages->text("menu", "statistics")] = 'index.php?action=statistics_STATS_CORE';
		}
		else if($this->multiUser && $this->userRegistration && !$this->userId)
				$this->wikindx[$messages->text("menu", "register")] = 'index.php?action=initRegisterUser';
		if($this->write)
			$this->wikindx[$messages->text("menu", "logout")] = 'index.php?action=logout';
		else
			$this->wikindx[$messages->text("menu", "userLogon")] = 'index.php?action=initLogon';
		$this->wikindx[$messages->text("menu", "about")] = 'index.php?action=help_ABOUT_CORE';
		$pubBrowseSub = $this->pubObject->browseMenuArray();
		$collBrowseSub = $this->collObject->browseMenuArray();
		$collEditSub = $this->collObject->editMenuArray();
		$pubEditSub = $this->pubObject->editMenuArray();
		if($this->write)
		{
			$this->res = array(
					$messages->text("menu", "res")		=>	'index.php?action=noMenu&method=res',
					$messages->text("menu", "new")	=> 'index.php?action=resource_RESOURCEFORM_CORE',
					'editSub' => array(
										$messages->text("menu", "editSub") => FALSE,
										$messages->text("menu", "creator")	=>	'index.php?action=edit_EDITCREATOR_CORE',
										$collEditSub,
										$pubEditSub,
										$messages->text("menu", "keyword")	=>	'index.php?action=edit_EDITKEYWORD_CORE',
						),
					'bookmarkSub' => array(
										$messages->text("menu", "bookmarkSub") => FALSE,
									),
					$messages->text("menu", "randomResource")	=>	
						'index.php?action=resource_RESOURCEVIEW_CORE&method=random',
				);
			if(empty($collEditSub))
				unset($this->res['editSub'][0]);
		}
		else
		{
			$this->res = array(
					$messages->text("menu", "res")		=>	'index.php?action=noMenu&method=res',
					'bookmarkSub' => array(
										$messages->text("menu", "bookmarkSub") => FALSE,
									),
					$messages->text("menu", "randomResource")	=>	
						'index.php?action=resource_RESOURCEVIEW_CORE&method=random',
				);
		}
		if(empty($collBrowseSub))
			unset($this->res['browseSub'][0]);
		if(empty($pubBrowseSub))
			unset($this->res['browseSub'][1]);
		$requireBookmark = FALSE;
		if($this->bookmarkAdd)
		{
			$found = FALSE;
			for($i = 1; $i <= 6; $i++)
			{
				if(array_key_exists($i . "_name", $this->bookmarkArray) && array_key_exists($i . "_id", $this->bookmarkArray)
					&& $this->bookmarkArray[$i . "_id"] == $this->lastSolo && ($this->bookmarkView == 'solo'))
				{
					$found = TRUE;
					break;
				}
				else if(array_key_exists($i . "_name", $this->bookmarkArray) && 
					array_key_exists($i . "_multi", $this->bookmarkArray) && ($this->bookmarkView == 'multi'))
				{
					$encodedSql = base64_encode($this->stmt);
					$bk = explode('|', $this->bookmarkArray[$i . "_multi"]); // statement, multi, listParams
					if($bk[0] == $encodedSql)
					{
						$found = TRUE;
						break;
					}
				}
			}
			if(!$found)
			{
				$this->res['bookmarkSub'][$messages->text("menu", "bookmarkAdd")] = 'index.php?action=bookmarks_BOOKMARK_CORE';
				$requireBookmark = TRUE;
			}
		}
		if(sizeof($this->bookmarkArray) > 2)
		{
			$this->res['bookmarkSub'][$messages->text("menu", "bookmarkDelete")] = 
				'index.php?action=bookmarks_BOOKMARK_CORE&method=deleteInit';
			for($i = 1; $i <= 20; $i++)
			{
				if(array_key_exists($i . "_name", $this->bookmarkArray) && 
					array_key_exists($i . "_id", $this->bookmarkArray))
					$this->res['bookmarkSub'][stripslashes($this->bookmarkArray[$i . "_name"])] = 
					"index.php?action=resource_RESOURCEVIEW_CORE&id=" . $this->bookmarkArray[$i . "_id"];
				else if(array_key_exists($i . "_name", $this->bookmarkArray) && 
					array_key_exists($i . "_multi", $this->bookmarkArray))
					$this->res['bookmarkSub'][stripslashes($this->bookmarkArray[$i . "_name"])] = 
					'index.php?action=bookmarks_BOOKMARK_CORE&method=multiView&id=' . $i;
			}
			$requireBookmark = TRUE;
		}
		if(!$requireBookmark)
			unset($this->res['bookmarkSub']);
		if($this->write)
		{
			$this->search = array(
					$messages->text("menu", "search")		=>	'index.php?action=noMenu&method=search',
					$messages->text("menu", "quickSearch")	=>	'index.php?action=list_QUICKSEARCH_CORE',
					$messages->text("menu", "searchResource")	=>	'index.php?action=list_SEARCHRESOURCES_CORE',
					$messages->text("menu", "selectResource")	=>	'index.php?action=list_SELECTRESOURCES_CORE',
					$messages->text("menu", "listResource")		=>	'index.php?action=list_LISTRESOURCES_CORE',
					'browseSub' => array(
										$messages->text("menu", "browseSub") => FALSE,
										$messages->text("menu", "browseType")	=>	
											'index.php?action=browse_BROWSETYPE_CORE',
										$messages->text("menu", "browseCreator")	=>	
											'index.php?action=browse_BROWSECREATOR_CORE',
										$messages->text("menu", "browseCited")	=>	
											'index.php?action=browse_BROWSECITED_CORE',
										$collBrowseSub,
										$pubBrowseSub,
										$messages->text("menu", "browseYear")	=>	
											'index.php?action=browse_BROWSEYEAR_CORE',
										$messages->text("menu", "browseKeyword")	=>	
											'index.php?action=browse_BROWSEKEYWORD_CORE',
										$messages->text("menu", "browseCategory")	=>	
											'index.php?action=browse_BROWSECATEGORY_CORE',
										$messages->text("menu", "browseSubcategory")	=>	
											'index.php?action=browse_BROWSESUBCATEGORY_CORE',
										$messages->text("menu", "browseLanguage")	=>	
											'index.php?action=browse_BROWSELANGUAGE_CORE',
										$messages->text("menu", "browseBibliography")	=>	
											'index.php?action=browse_BROWSEBIBLIOGRAPHY_CORE',
										$messages->text("menu", "browseUser")	=>	
											'index.php?action=browse_BROWSEUSER_CORE&method=user',
										$messages->text("menu", "browseDept")	=>	
											'index.php?action=browse_BROWSEUSER_CORE&method=department',
										$messages->text("menu", "browseInst")	=>	
											'index.php?action=browse_BROWSEUSER_CORE&method=institution',
									),
					$messages->text("menu", "categoryTree")	=>	'index.php?action=browse_CATEGORYTREE_CORE',
					$messages->text("menu", "searchMeta")	=>	'index.php?action=list_SEARCHMETADATA_CORE',
					$messages->text("menu", "selectMeta")	=>	'index.php?action=list_SELECTMETADATA_CORE',
			);
			$userTagsObject = FACTORY_USERTAGS::getInstance();
			$userTags = $userTagsObject->grabAll($this->session->getVar('mywikindx_Bibliography_use'));
			if(!empty($userTags))
				$this->search['browseSub'][$messages->text("menu", "browseUserTags")] = 'index.php?action=browse_BROWSEUSERTAGS_CORE';
		}
		else
		{
			$this->search = array(
					$messages->text("menu", "search")		=>	'index.php?action=noMenu&method=search',
					$messages->text("menu", "quickSearch")	=>	'index.php?action=list_QUICKSEARCH_CORE',
					$messages->text("menu", "searchResource")	=>	'index.php?action=list_SEARCHRESOURCES_CORE',
					$messages->text("menu", "selectResource")	=>	'index.php?action=list_SELECTRESOURCES_CORE',
					$messages->text("menu", "listResource")		=>	'index.php?action=list_LISTRESOURCES_CORE',
					'browseSub' => array(
										$messages->text("menu", "browseSub") => FALSE,
										$messages->text("menu", "browseType")	=>	
											'index.php?action=browse_BROWSETYPE_CORE',
										$messages->text("menu", "browseCreator")	=>	
											'index.php?action=browse_BROWSECREATOR_CORE',
										$messages->text("menu", "browseCited")	=>	
											'index.php?action=browse_BROWSECITED_CORE',
										$collBrowseSub,
										$pubBrowseSub,
										$messages->text("menu", "browseYear")	=>	
											'index.php?action=browse_BROWSEYEAR_CORE',
										$messages->text("menu", "browseKeyword")	=>	
											'index.php?action=browse_BROWSEKEYWORD_CORE',
										$messages->text("menu", "browseCategory")	=>	
											'index.php?action=browse_BROWSECATEGORY_CORE',
										$messages->text("menu", "browseSubcategory")	=>	
											'index.php?action=browse_BROWSESUBCATEGORY_CORE',
										$messages->text("menu", "browseLanguage")	=>	
											'index.php?action=browse_BROWSELANGUAGE_CORE',
										$messages->text("menu", "browseUser")	=>	
											'index.php?action=browse_BROWSEUSER_CORE&method=user',
										$messages->text("menu", "browseDept")	=>	
											'index.php?action=browse_BROWSEUSER_CORE&method=department',
										$messages->text("menu", "browseInst")	=>	
											'index.php?action=browse_BROWSEUSER_CORE&method=institution',
									),
					$messages->text("menu", "categoryTree")	=>	'index.php?action=browse_CATEGORYTREE_CORE',
					$messages->text("menu", "searchMeta")	=>	'index.php?action=list_SEARCHMETADATA_CORE',
					$messages->text("menu", "selectMeta")	=>	'index.php?action=list_SELECTMETADATA_CORE',
			);
		}
		if(!$this->metadataExist)
		{
			unset($this->search[$messages->text("menu", "selectMeta")]);
			unset($this->search[$messages->text("menu", "searchMeta")]);
		}
		$this->text = array(
				$messages->text("menu", "text")		=>	'index.php?action=noMenu&method=text',
				'randomSub' => array(
									$messages->text("menu", "randomSub") => FALSE,
									$messages->text("menu", "randomQuotes")	=> 
										'index.php?action=metadata_RANDOMMETADATA_CORE&method=randomQuote',
									$messages->text("menu", "randomParaphrases")	=>
										'index.php?action=metadata_RANDOMMETADATA_CORE&method=randomParaphrase',
									$messages->text("menu", "randomMusings")	=>
										'index.php?action=metadata_RANDOMMETADATA_CORE&method=randomMusing',
								),
				$messages->text("menu", "browseKeyword")	=>	'index.php?action=browse_BROWSEKEYWORD_CORE&metadata=1',
			);
		if($this->lastSolo)
			$this->res[$messages->text("menu", "lastSolo")] = 'index.php?action=resource_RESOURCEVIEW_CORE&id=' . 
			$this->lastSolo;
		if($this->lastMulti)
			$this->res[$messages->text("menu", "lastMulti")] = 'index.php?' . $this->lastMulti . '&type=lastMulti';
		$basket = unserialize($this->basketList);
		if($this->basketList && !empty($basket))
		{
			$this->res['basketSub'] = array(
									$messages->text("menu", "basketSub") => FALSE,
									$messages->text("menu", "basketView") => 'index.php?action=basket_BASKET_CORE&method=view',
									$messages->text("menu", "basketDelete") => 'index.php?action=basket_BASKET_CORE&method=delete',
								);
		}
		if($this->lastMultiMeta)
		{
			$this->text[$messages->text("menu", "lastMultiMeta")] = 'index.php?action=lastMultiMeta';
			$this->text[$messages->text("menu", "rtfexp")] = 'index.php?action=metaExportRtf';
		}
		if($this->write)
		{
			if($this->session->getVar('setup_MaxPaste') || $this->superAdmin)
				$this->res[$messages->text("menu", "pasteBibtex")] = 'index.php?action=import_PASTEBIBTEX_CORE';
			if($this->importBib && !$this->superAdmin)
			{
				$this->res[$messages->text("menu", "importBibtex")] = 'index.php?action=import_BIBTEXFILE_CORE';
			}
		}
		else // Read Only
			unset($this->res['browseSub'][$messages->text("menu", "browseBibliography")]);
		$this->admin = array(
				$messages->text("menu", "admin")	=>	'index.php?action=noMenu&method=admin',
				$messages->text("menu", "conf")		=>'index.php?action=admin_CONFIGURE_CORE',
				'newsSub' => array(
									$messages->text("menu", "newsSub") => FALSE,
									$messages->text("menu", "newsAdd")	=>	
										'index.php?action=news_NEWS_CORE&method=initAdd',
									$messages->text("menu", "newsEdit")	=> 
										'index.php?action=news_NEWS_CORE&method=initEdit',
									$messages->text("menu", "newsDelete")	=>	
										'index.php?action=news_NEWS_CORE&method=initDelete',
								),
				'categorySub' => array(
									$messages->text("menu", "categorySub") => FALSE,
									$messages->text("menu", "categoryAdd")	=>	
										'index.php?action=admin_ADMINCATEGORIES_CORE&method=addInit',
									$messages->text("menu", "categoryEdit")	=> 
										'index.php?action=admin_ADMINCATEGORIES_CORE&method=editInit',
									$messages->text("menu", "categoryDelete")	=>	
										'index.php?action=admin_ADMINCATEGORIES_CORE&method=deleteInit',
								),
				'subcategorySub' => array(
									$messages->text("menu", "subcategorySub") => FALSE,
									$messages->text("menu", "subcategoryAdd")	=>	
										'index.php?action=admin_ADMINCATEGORIES_CORE&method=addSubInit',
									$messages->text("menu", "subcategoryEdit")	=> 
										'index.php?action=admin_ADMINCATEGORIES_CORE&method=editSubInit',
									$messages->text("menu", "subcategoryDelete")	=>	
										'index.php?action=admin_ADMINCATEGORIES_CORE&method=deleteSubInit',
								),
				'customSub' => array(
									$messages->text("menu", "customSub") => FALSE,
									$messages->text("menu", "customAdd")	=>	
										'index.php?action=admin_ADMINCUSTOM_CORE&method=addInit',
									$messages->text("menu", "customEdit")	=> 
										'index.php?action=admin_ADMINCUSTOM_CORE&method=editInit',
									$messages->text("menu", "customDelete")	=>	
										'index.php?action=admin_ADMINCUSTOM_CORE&method=deleteInit',
								),
				'languageSub' => array(
									$messages->text("menu", "languageSub") => FALSE,
									$messages->text("menu", "languageAdd")	=>	
										'index.php?action=admin_ADMINLANGUAGES_CORE&method=addInit',
									$messages->text("menu", "languageEdit")	=> 
										'index.php?action=admin_ADMINLANGUAGES_CORE&method=editInit',
									$messages->text("menu", "languageDelete")	=>	
										'index.php?action=admin_ADMINLANGUAGES_CORE&method=deleteInit',
								),
				'userSub' => array(
									$messages->text("menu", "userSub") => FALSE,
									$messages->text("menu", "userAdd")	=>	
										'index.php?action=admin_ADMINUSER_CORE&method=addInit',
									$messages->text("menu", "userEdit")	=> 
										'index.php?action=admin_ADMINUSER_CORE&method=editInit',
									$messages->text("menu", "userDelete")	=>	
										'index.php?action=admin_ADMINUSER_CORE&method=deleteInit',
									$messages->text("menu", "userRegistration")	=>	
										'index.php?action=admin_ADMINUSER_CORE&method=registrationInit',
								),
				'keywordSub' => array(
									$messages->text("menu", "keywordSub") => FALSE,
									$messages->text("menu", "keywordEdit")	=> 
										'index.php?action=admin_ADMINKEYWORD_CORE&method=editInit',
									$messages->text("menu", "keywordMerge")	=>	
										'index.php?action=admin_ADMINKEYWORD_CORE&method=mergeInit',
									$messages->text("menu", "keywordDelete")	=>	
										'index.php?action=admin_ADMINKEYWORD_CORE&method=deleteInit',
								),
				'creatorSub' => array(
									$messages->text("menu", "creatorSub") => FALSE,
									$messages->text("menu", "creatorMerge")	=>	
										'index.php?action=admin_ADMINCREATOR_CORE&method=mergeInit',
									$messages->text("menu", "creatorGroup")	=>	
										'index.php?action=admin_ADMINCREATOR_CORE&method=groupInit',
									$messages->text("menu", "creatorUngroup")	=>	
										'index.php?action=admin_ADMINCREATOR_CORE&method=ungroupInit',
								),
				$messages->text("menu", "delete") => 'index.php?action=admin_DELETERESOURCE_CORE',
				$messages->text("menu", "importBibtex")	=> 'index.php?action=import_BIBTEXFILE_CORE',
			);
		if($this->pluginsExist)
			$this->admin[$messages->text("menu", "adminPlugins")] = 'index.php?action=admin_ADMINPLUGINS_CORE';
		if(($this->session->getVar('setup_Quarantine') == 'Y') && $this->quarantine->checkQuarantine())
			$this->admin[$messages->text("menu", "quarantine")] = 'index.php?action=admin_QUARANTINE_CORE&method=listQuarantined';
		if($this->multiUser == 'N')
			unset($this->admin['userSub']);
// Disable menu items if there are not yet resources
		if(!$this->resourcesExist)
		{
			unset($this->admin[$messages->text("menu", "delete")]);
			unset($this->admin['keywordSub']);
			unset($this->admin['creatorSub']);
			unset($this->res['searchSub']);
			if($this->write)
				unset($this->res['editSub']);
			unset($this->res['browseSub']);
			unset($this->res[$messages->text("menu", "categoryTree")]);
			unset($this->res[$messages->text("menu", "randomResource")]);
			unset($this->wikindx[$messages->text("menu", "statistics")]);
		}
// Remove 'edit' array from resource array if non-admins not allowed to edit
		if($this->resourcesExist && $this->write) // if no resources, editSub does not exist anyway
		{
			if(!$this->config->WIKINDX_GLOBAL_EDIT && !$this->superAdmin)
				array_splice($this->res, array_search('editSub', array_keys($this->res)), 1);
		}
	}
/**
* Insert available modules into menu system
*/
	private function menuInsert()
	{
		include_once("core/modules/LOADEXTERNALMODULES.php");
		$loadmodules = new LOADEXTERNALMODULES();
// no modules to be loaded
		if(!$moduleList = $loadmodules->readPluginsDirectory())
			return;
		$menuHeadings = array("wikindx", "res", "search", "text", "admin", "plugin1", "plugin2", "plugin3");
// else, $moduleList is an array of valid directory names in $loadmodules->moduleDirectory
		foreach($moduleList as $dirName)
		{
			include_once($loadmodules->moduleDirectory . $dirName . '/index.php');
// class name must be in the form $dirName . MODULE
			$module = $dirName . "_MODULE";
			if(!class_exists($module))
				continue;
			$class = new $module(TRUE);
// $authorize:	0 -> menu item displayed for all users
//			1 -> menu item displayed for users with write access
//			2 -> menu item displayed only for admins.
			if(isset($class->authorize) && ($class->authorize == 2) && !$this->superAdmin)
				continue; // don't write to menu
			else if(isset($class->authorize) && ($class->authorize == 1) && !$this->write)
				continue; // don't write to menu
// Check we have valid menu plugs, if so, insert into menu
			if(isset($class->menus))
			{
				foreach($class->menus as $menu => $array)
				{
					if((array_search($menu, $menuHeadings) !== FALSE) && is_array($array))
					{
						foreach($array as $entry => $action)
						{
							if($entry && is_array($action))
							{
								$subMenu = array();
								foreach($action as $key => $value)
								{
									if($value === FALSE)
										$subMenu[$key] = $value;
									else if(method_exists($class, $value))
										$subMenu[$key] = 'index.php?action=' . $dirName . '_' . $value;
								}
								if(!empty($subMenu))
									$this->{$menu}[$entry] = $subMenu;
							}
							else if($entry && $action && method_exists($class, $action))
								$this->{$menu}[$entry] = 'index.php?action=' . $dirName . '_' . $action;
						}
					}
				}
			}
		}
	}
/**
* Create a sub-sub menu
*
* @param array $link
* @param string $menuSub Reference to
*/
	private function doSubSubMenu($link, &$menuSub)
	{
		$topLevelSub = each($link);
		SmartyMenu::setItemText($menuSub, $topLevelSub['key']);
		SmartyMenu::setItemLink($menuSub, $topLevelSub['value']);
		SmartyMenu::initItem($itemSubSub);
		SmartyMenu::initMenu($subSub);
		while(list($subText, $subLink) = each($link))
		{
			SmartyMenu::setItemText($itemSubSub, $subText);
			SmartyMenu::setItemLink($itemSubSub, $subLink);
			SmartyMenu::addMenuItem($subSub, $itemSubSub);
		}
		SmartyMenu::setItemSubmenu($menuSub, $subSub);
	}
/**
* Create a sub menu
*
* @param array $link
* @param string $menu Reference to
*/
	private function doSubMenu($link, &$menu)
	{
		$topLevelSub = each($link);
		SmartyMenu::setItemText($item, $topLevelSub['key']);
		SmartyMenu::setItemLink($item, $topLevelSub['value']);
		SmartyMenu::initItem($itemSub);
		SmartyMenu::initMenu($sub);
		while(list($subText, $subLink) = each($link))
		{
			if(is_array($subLink))
			{
				if($this->reduceMenuLevel == 1) // remove one submenu level
				{
					$index = 0;
					while(list($subText1, $subLink1) = each($subLink))
					{
						if($index)
							SmartyMenu::setItemText($itemSub, $this->reduceMenuLevelPretext . $subText1);
						else
							SmartyMenu::setItemText($itemSub, $subText1);
						SmartyMenu::setItemLink($itemSub, $subLink1);
						SmartyMenu::addMenuItem($sub, $itemSub);
						++$index;
					}
				}
				else // keep all submenus
				{
					$this->doSubSubMenu($subLink, $itemSub);
					SmartyMenu::addMenuItem($sub, $itemSub);
				}
			}
			else
			{
				SmartyMenu::setItemText($itemSub, $subText);
				SmartyMenu::setItemLink($itemSub, $subLink);
				SmartyMenu::addMenuItem($sub, $itemSub);
			}
			unset($itemSub);
		}
		SmartyMenu::setItemSubmenu($item, $sub);
		SmartyMenu::addMenuItem($menu, $item);
	}
/**
* Create a menu array
*
* @param array $array
* @param string $label
* @param string $menu Reference to
*/
	private function createMenuArray($array, $label, &$menu)
	{
// Remove top level of menu array in readiness for Top Level of menu below
		$this->topLevel[$label] = each($array);
		SmartyMenu::initItem($item);
		while(list($text, $link) = each($array))
		{
			if(is_array($link))
			{
				if($this->reduceMenuLevel == 2) // remove all submenu levels
				{
					$index = 0;
					$subArray = array();
					foreach($link as $subText => $subLink)
					{
						if(!$index)
						{
							SmartyMenu::setItemText($item, $subText);
							$title = $subText;
							++$index;
							continue;
						}
						$subArray[$subText] = $subLink;
						++$index;
					}
					if(!empty($subArray))
					{
						$serial = base64_encode(serialize($subArray));
						SmartyMenu::setItemLink($item, "index.php?action=noSubMenu&method=$title&array=$serial");
						SmartyMenu::addMenuItem($menu, $item);
					}
				}
				else
					$this->doSubMenu($link, $menu);
			}
			else
			{
				SmartyMenu::setItemText($item, $text);
				SmartyMenu::setItemLink($item, $link);
				SmartyMenu::addMenuItem($menu, $item);
			}
		}
	}
/**
* print menus
*
* submenus have to be created before the menu item is
*/
	public function menus()
	{
// if setup_language not set, this is an admin about to configure WIKINDX for the first time.
//		if(!$this->session->getVar("setup_Language"))
//			return FALSE;
		$this->configure();
		SmartyMenu::initMenu($subMenu);
// Check for plug-in modules
		$this->menuInsert();
		$this->createMenuArray($this->wikindx, 'wikindx', $wikindxSub);
		array_push($this->menuSub, $wikindxSub);
		if(isset($this->bookmark))
		{
			$this->createMenuArray($this->bookmark, 'bookmark', $bookmarkSub);
			array_push($this->menuSub, $bookmarkSub);
		}
		if($this->resourcesExist || $this->write)
		{
			$this->createMenuArray($this->res, 'resource', $resourceSub);
			array_push($this->menuSub, $resourceSub);
		}
		if($this->resourcesExist)
		{
			$this->createMenuArray($this->search, 'search', $searchSub);
			array_push($this->menuSub, $searchSub);
		}
		if($this->resourcesExist && $this->metadataExist)
		{
			$this->createMenuArray($this->text, 'metadata', $metadataSub);
			array_push($this->menuSub, $metadataSub);
		}
// If not admin, don't display admin menu
		if($this->superAdmin)
		{
			$this->createMenuArray($this->admin, 'admin', $adminSub);
			array_push($this->menuSub, $adminSub);
		}
		if(sizeof($this->plugin1) > 1)
		{
			$this->createMenuArray($this->plugin1, 'plugin1', $plugin1Sub);
			array_push($this->menuSub, $plugin1Sub);
		}
		if(sizeof($this->plugin2) > 1)
		{
			$this->createMenuArray($this->plugin2, 'plugin2', $plugin2Sub);
			array_push($this->menuSub, $plugin2Sub);
		}
		if(sizeof($this->plugin3) > 1)
		{
			$this->createMenuArray($this->plugin3, 'plugin3', $plugin3Sub);
			array_push($this->menuSub, $plugin3Sub);
		}
// Top level of above subMenus
		SmartyMenu::initMenu($menu);
		foreach($this->topLevel as $menuArray)
		{
			SmartyMenu::initItem($item);
			SmartyMenu::setItemText($item, $menuArray['key']);
			SmartyMenu::setItemLink($item, $menuArray['value']);
// Add in subMenu
			$menuSub = array_shift($this->menuSub);
			SmartyMenu::setItemSubmenu($item, $menuSub);
			SmartyMenu::addMenuItem($menu, $item);
		}
		$this->template->tpl->assign('menu', $menu);
		SmartyMenu::saveMenu('menu_menu', $menu);
	}
/**
* no menu system
*
* Produce standard hyperlinks in body of page
**/
	public function noMenu()
	{
		$vars = GLOBALS::getVars();
		$type = $vars['method'];
		$this->html = FACTORY_HTML::getInstance();
		$messages = FACTORY_MESSAGES::getInstance();
		$this->configure();
// Check for plug-in modules
		$this->menuInsert();
		if($type == 'wikindx')
		{
			GLOBALS::setOutputHeading('Wikindx');
			$type = 'wikindx';
		}
		else
			GLOBALS::setOutputHeading($messages->text("menu", $type));
		array_shift($this->$type);
		foreach($this->$type as $key => $value)
			$this->outputArray[] = $this->subNoMenu($key, $value);
		GLOBALS::buildOutputString(join($this->html->br(), $this->outputArray));
	}
/**
* no submenu system
*
* Produce standard hyperlinks in body of page
**/
	public function noSubMenu()
	{
		$vars = GLOBALS::getVars();
		$array = unserialize(base64_decode($vars['array']));
		$this->html = FACTORY_HTML::getInstance();
		$messages = FACTORY_MESSAGES::getInstance();
		$this->configure();
// Check for plug-in modules
		$this->menuInsert();
		GLOBALS::setOutputHeading($vars['method']);
		foreach($array as $key => $value)
			$this->outputArray[] = $this->subNoMenu($key, $value);
		GLOBALS::buildOutputString(join($this->html->br(), $this->outputArray));
	}
/**
* Elements of noMenu display -- with subMenus and subSubMenus
*
* @param string $key
* @param string $value
* @return string
*/
	private function subNoMenu($key, $value)
	{
		$spacing = '&nbsp;&nbsp;&nbsp;&nbsp;';
		$pString = '';
		if(is_array($value)) // sub menu
		{
			$index = 0;
			foreach($value as $subKey => $subValue)
			{
				if(!$index)
				{
					if(is_array($subValue))
					{
						$subIndex = 0;
						foreach($subValue as $subSubKey => $subSubValue)
						{
							if(!$subIndex)
							{
								$pString .= $this->html->br() . $spacing . $subSubKey;
								++$subIndex;
								continue;
							}
							$pString .= $this->html->span($this->html->a("link", $subSubKey, $subSubValue)) . $spacing;
						}
						$pString .= $this->html->br() . $spacing;
					}
					else
						$pString .= $subKey . $spacing;
					$index++;
					continue;
				}
				if(is_array($subValue)) // sub submenu
				{
					$subIndex = 0;
					foreach($subValue as $subSubKey => $subSubValue)
					{
						if(!$subIndex)
						{
							$pString .= $this->html->br() . $spacing . $subSubKey;
							++$subIndex;
							continue;
						}
						$pString .= $this->html->span($this->html->a("link", $subSubKey, $subSubValue)) . $spacing;
					}
					$pString .= $this->html->br() . $spacing;
				}				
				else
					$pString .= $this->html->span($this->html->a("link", $subKey, $subValue)) . $spacing;
			}
		}
		else
			$pString .= $this->html->span($this->html->a("link", $key, $value));
		return $pString;
	}
}
?>
