/**********************************************************************************
WIKINDX: Bibliographic Management system.
Copyright (C)

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the 
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

The WIKINDX Team 2011
sirfragalot@users.sourceforge.net

**********************************************************************************/

/**
* template.js
*
* This file provides the opportunity to alter the CSS display dependent upon certain browsers and to define various pop-up windows.
* template.js is loaded from header.tpl.
* initTemplate() is called in the onLoad function of the body tag in header.tpl.
* The minimum template.js should look like:

function initTemplate()
{
}
*/

var agt=navigator.userAgent.toLowerCase();
var is_nav  = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1)
                && (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1)
                && (agt.indexOf('webtv')==-1) && (agt.indexOf('hotjava')==-1));
var is_ie     = ((agt.indexOf("msie") != -1) && (agt.indexOf("opera") == -1));
var is_opera = (agt.indexOf("opera") != -1);
var is_win   = ((agt.indexOf("win")!=-1) || (agt.indexOf("16bit")!=-1));
var is_mac    = (agt.indexOf("mac")!=-1);
var is_safari = (agt.indexOf("safari") != -1);
var is_konqueror = (agt.indexOf("konqueror") != -1);
var is_gecko = (agt.indexOf("gecko") != -1);

/* ===== common JavaScript functions ===== */
/* ===== Code that should remain here although you can edit various parameters (window sizes, for example). ===== */

/**
* Open pop-up CMS window
*/
function openCmsWindow(url){
 browserDimensions();
 var w = browserWidth * 0.95;
 var h = browserHeight * 0.9;
 var cmsWindow = window.open(url,'winCms','height=' + h + 
	',width=' + w + ',left=10,top=10,status,scrollbars,resizable,dependent');
}
/**
* Open pop-up BIBTEX window
*/
function openBibtexWindow(url){
 browserDimensions();
 var w = browserWidth * 0.95;
 var h = browserHeight * 0.9;
 var bibtexWindow = window.open(url,'winBibtex','height=' + h + 
	',width=' + w + ',left=10,top=10,status,scrollbars,resizable,dependent');
}
/**
* Open pop-up email to friend window
*/
function openEmailFriendWindow(url){
 browserDimensions();
 var w = browserWidth * 0.6;
 var h = browserHeight * 0.6;
 var emailWindow = window.open(url,'winFriend','height=' + h + 
	',width=' + w + ',left=10,top=10,status,scrollbars,resizable,dependent');
}
/**
* Open pop-up Help window
*/
function openHelpWindow(url){
 browserDimensions();
 var w = browserWidth * 0.6;
 var h = browserHeight * 0.6;
 var helpWindow = window.open(url,'winHelp','height=' + h + 
	',width=' + w + ',left=10,top=10,status,scrollbars,resizable,dependent');
}
/**
* pop-up window for single resources formatted to Endnote, bibtex or RIS
* 
* @Author Mark Grimshaw with a lot of help from Christian Boulanger
*/
function formatResource(url, string)
{
	browserDimensions();
	var w = browserWidth * 0.95;
	var h = browserHeight * 0.4;;
	var popUp = window.open(url,'winMeta','height=' + h + ',width=' + w + 
		',left=10,top=10,status,scrollbars,resizable,dependent');
}
/**
* Get browser dimensions.
* Code adapted from http://www.howtocreate.co.uk/tutorials/index.php?tut=0&part=16
*/
function browserDimensions()
{
	if( typeof( window.innerWidth ) == 'number' )
	{
//Non-IE
		browserWidth = window.innerWidth;
		browserHeight  = window.innerHeight;
	}
	else if( document.documentElement &&
      ( document.documentElement.clientWidth || document.documentElement.clientHeight ) )
	{
//IE 6+ in 'standards compliant mode'
		browserWidth = document.documentElement.clientWidth;
		browserHeight  = document.documentElement.clientHeight;
	}
	else if( document.body && ( document.body.clientWidth || document.body.clientHeight ) )
	{
//IE 4 compatible
		browserWidth = document.body.clientWidth;
		browserHeight  = document.body.clientHeight;
	}
}
